_G["SolaceGlyphs"] = SolaceGlyphs or { version = "4.0.1-r1" }

local Gratuity = LibStub:GetLibrary("LibGratuity-3.0")
local SolaceLib = _G["SolaceLib"]
local print = _G["print"] or function(txt) DEFAULT_CHAT_FRAME:AddMessage(txt) end

SolaceGlyphs["commandsInit"] = SolaceLib["commandsInit"]
SolaceGlyphs:commandsInit("glyphs", SG_CMD_DESC, "Print")

function SolaceGlyphs:Print(msg)
	local index = 0
	local first = GetFirstTradeSkill()
	local last = GetNumTradeSkills() + first
	local minors = {}
	local majors = {}
	local primes = {}
	
	if ( not ( msg == "minor" or msg == "major" or msg == "prime" or not msg) ) then
		print(SG_CMD_DESC)
		return
	end
	
	for index = first, last do
		local link = GetTradeSkillItemLink(index)
		
		if link then
			local glyphType = SolaceGlyphs:getGlyphType(link)
			local eLink = GetTradeSkillRecipeLink(index)
			
			if ( msg == "minor" or not (type(msg) == "string") ) then
				if ( glyphType == MINOR_GLYPH ) then
					local t = { ["index"] = index, ["link"] = eLink }
					table.insert(minors, t)
				end
			end
			if ( msg == "major" or not (type(msg) == "string") ) then
				if ( glyphType == MAJOR_GLYPH ) then
					local t = { ["index"] = index, ["link"] = eLink }
					table.insert(majors, t)
				end
			end
			if ( msg == "prime" or not (type(msg) == "string") ) then
				if ( glyphType == PRIME_GLYPH ) then
					local t = { ["index"] = index, ["link"] = eLink }
					table.insert(primes, t)
				end
			end
		end
	end
	local firstrun = true
	while (table.getn(primes)>0) do
		if (firstrun) then
			print(SG_CREATABLE_PRIME)
			firstrun = false
		end
		print("    "..SG_PREFIX_PRIME..table.remove(primes,1)["link"])
	end
	local firstrun = true
	while (table.getn(majors)>0) do
		if (firstrun) then
			print(SG_CREATABLE_MAJOR)
			firstrun = false
		end
		print("    "..SG_PREFIX_MAJOR..table.remove(majors,1)["link"])
	end
	local firstrun = true
	while (table.getn(minors)>0) do
		if (firstrun) then
			print(SG_CREATABLE_MINOR)
			firstrun = false
		end
		print("    "..SG_PREFIX_MINOR..table.remove(minors,1)["link"])
	end
end

function SolaceGlyphs:getGlyphType(link)
	if (link) then
		Gratuity:SetHyperlink(link)
		
		local isMinor = Gratuity:Find(MINOR_GLYPH,1,4)
		local isMajor = Gratuity:Find(MAJOR_GLYPH,1,4)
		local isPrime = Gratuity:Find(PRIME_GLYPH,1,4)
		
		if isMinor then
			return MINOR_GLYPH
		elseif isMajor then
			return MAJOR_GLYPH
		elseif isPrime then
			return PRIME_GLYPH
		end
	end
	
	return nil
end

local GetTradeSkillInfo_old = GetTradeSkillInfo
function GetTradeSkillInfo_SG(skillIndex)
	local skillName, skillType, numAvailable, isExpanded, altVerb, numSkillUps = GetTradeSkillInfo_old(skillIndex)
	local link = GetTradeSkillItemLink(skillIndex)
	if (link) then
		local glyphType = SolaceGlyphs:getGlyphType(link)
		
		if ( glyphType == MINOR_GLYPH ) then
			skillName = SG_PREFIX_MINOR..skillName
		elseif ( glyphType == MAJOR_GLYPH ) then
			skillName = SG_PREFIX_MAJOR..skillName
		elseif ( glyphType == PRIME_GLYPH ) then
			skillName = SG_PREFIX_PRIME..skillName
		end
	end
	
	return skillName, skillType, numAvailable, isExpanded, altVerb, numSkillUps
end
GetTradeSkillInfo = GetTradeSkillInfo_SG