SGK_version = "4.0.1_dev1"

local lth = LibStub:GetLibrary("LibTipHooker-1.1")

local SGK_frame = CreateFrame("Frame", nil, UIParent)
SGK_frame:RegisterEvent("USE_GLYPH")
SGK_frame:RegisterEvent("PLAYER_ALIVE")
SGK_frame:RegisterEvent("PLAYER_LOGIN")

SGK_knownGlyphs = {}
local SGK_player_alive = false
function SGK_onEvent(self, event, ...)
	if ( event == "USE_GLYPH" or event == "PLAYER_ALIVE" ) then
		if event == "PLAYER_ALIVE" then SGK_player_alive = true end
		if SGK_player_alive then
			local numGlyphs = GetNumGlyphs()
			local playerName = UnitName("player")
			local playerRealm = GetRealmName()
			
			for i = 1, numGlyphs do
				local name, glyphType, isKnown, icon, castSpell = GetGlyphInfo(i)
				
				if ( isKnown and name ~= "header" ) then
					name = SGK_GLYPH_OF..name
					if not SGK_knownGlyphs[name] then SGK_knownGlyphs[name] = {} end
					if not SGK_knownGlyphs[name][playerRealm] then SGK_knownGlyphs[name][playerRealm] = {} end
					SGK_knownGlyphs[name][playerRealm][playerName] = true
				end
			end
		end
	end
end
SGK_frame:SetScript("OnEvent",SGK_onEvent)

local function SGK_tipHandler(tooltip, name, link, ...)
	local playerRealm = GetRealmName()
	
	if ( SGK_knownGlyphs[name] ) then if ( SGK_knownGlyphs[name][playerRealm] ) then
		local chars = ""
		for k, v in pairs(SGK_knownGlyphs[name][playerRealm]) do
			if v then
				if strlen(chars) > 0 then chars = chars..", " end
				chars = chars..k
			end
		end
		tooltip:AddLine(YELLOW_FONT_COLOR_CODE..SGK_KNOWN_BY..FONT_COLOR_CODE_CLOSE..chars.."\n", 1, 1, 1, true)
		tooltip:Show()
	end end
end
lth:Hook(SGK_tipHandler, "item")